qpid::client::SubscriptionSettings Struct Reference

Apache Qpid - AMQP Messaging for Java JMS, C++, Python, Ruby, and .NET | Apache Qpid Documentation

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes
qpid::client::SubscriptionSettings Struct Reference

Settings for a subscription. More...

`#include <qpid/client/SubscriptionSettings.h>`

List of all members.

## Public Member Functions
| SubscriptionSettings (FlowControl flow=FlowControl::unlimited(), AcceptMode accept=ACCEPT_MODE_EXPLICIT, AcquireMode acquire=ACQUIRE_MODE_PRE_ACQUIRED, unsigned int autoAck_=1, CompletionMode completion=COMPLETE_ON_DELIVERY)
## Public Attributes
FlowControl | flowControl
AcceptMode | acceptMode
| < Flow control settings.
AcquireMode | acquireMode
| < ACCEPT_MODE_EXPLICIT or ACCEPT_MODE_NONE
unsigned int | autoAck
| < ACQUIRE_MODE_PRE_ACQUIRED or ACQUIRE_MODE_NOT_ACQUIRED
CompletionMode | completionMode
| In windowing mode, completion of a message will cause the credit used up by that message to be reallocated.
bool | exclusive
| If set, requests that no other subscriber be allowed to access the queue while this subscription is active.

## Detailed Description

Settings for a subscription.

## Constructor & Destructor Documentation

qpid::client::SubscriptionSettings::SubscriptionSettings | ( | FlowControl | flow = `FlowControl::unlimited()`,
|  | AcceptMode | accept = `ACCEPT_MODE_EXPLICIT`,
|  | AcquireMode | acquire = `ACQUIRE_MODE_PRE_ACQUIRED`,
|  | unsigned int | autoAck_ = `1`,
|  | CompletionMode | completion = `COMPLETE_ON_DELIVERY`
| ) |  | `[inline]`

Definition at line 43 of file SubscriptionSettings.h.

## Member Data Documentation

AcceptMode qpid::client::SubscriptionSettings::acceptMode

< Flow control settings.

See also:
  FlowControl The acceptMode determines whether the broker should expect delivery of messages to be acknowledged by the client indicating that it accepts them. A value of ACCEPT_MODE_EXPLICIT means that messages must be accepted (note: this may be done automatically by the library - see autoAck - or through an explicit call be the application - see Subscription::accept()) before they can be dequeued. A value of ACCEPT_MODE_NONE means that the broker can dequeue a message as soon as it is acquired.

Definition at line 63 of file SubscriptionSettings.h.

AcquireMode qpid::client::SubscriptionSettings::acquireMode

< ACCEPT_MODE_EXPLICIT or ACCEPT_MODE_NONE

The acquireMode determines whether messages are locked for the subscriber when delivered, and thus are not delivered to any other subscriber unless this subscriber releases them.

The default is ACQUIRE_MODE_PRE_ACQUIRED meaning that the subscriber expects to have been given that message exclusively (i.e. the message will not be given to any other subscriber unless released explicitly or by this subscribers session failing without having accepted the message).

Delivery of message in ACQUIRE_MODE_NOT_ACQUIRED mode means the message will still be available for other subscribers to receive. The application can if desired acquire a (set of) messages through an explicit acquire call - see Subscription::acquire().

Definition at line 81 of file SubscriptionSettings.h.

unsigned int qpid::client::SubscriptionSettings::autoAck

< ACQUIRE_MODE_PRE_ACQUIRED or ACQUIRE_MODE_NOT_ACQUIRED

Configures the frequency at which messages are automatically accepted (e.g. a value of 5 means that messages are accepted in batches of 5). A value of 0 means no automatic acknowledgement will occur and the application will itself be responsible for accepting messages.

Definition at line 90 of file SubscriptionSettings.h.

CompletionMode qpid::client::SubscriptionSettings::completionMode

In windowing mode, completion of a message will cause the credit used up by that message to be reallocated.

The subscriptions completion mode controls how completion is managed.

If set to COMPLETE_ON_DELIVERY (which is the default), messages will be marked as completed once they have been received. The server will be explicitly notified of all completed messages for the session when the next accept is sent through the subscription (either explictly or through autAck). However the server may also periodically request information on the completed messages.

If set to COMPLETE_ON_ACCEPT, messages will be marked as completed once they are accepted (via the Subscription class) and the server will also be notified of all completed messages for the session.

If set to MANUAL_COMPLETION the application is responsible for completing messages (

See also:
  Session::markCompleted()).

Definition at line 113 of file SubscriptionSettings.h.

bool qpid::client::SubscriptionSettings::exclusive

If set, requests that no other subscriber be allowed to access the queue while this subscription is active.

Definition at line 118 of file SubscriptionSettings.h.

FlowControl qpid::client::SubscriptionSettings::flowControl

Definition at line 51 of file SubscriptionSettings.h.

The documentation for this struct was generated from the following file:

- qpid/client/SubscriptionSettings.h